image: node:latest

stages:
    - build
    - test

cache:
    paths:
        - node_modules/
        
build_job:
    stage: build
    script:
        - npm install
        - npm run build-ci
    artifacts:
        paths:
            - dist/*

test_job:
    stage: test
    script:
       - npm run test-ci
    artifacts:
        paths:
            - coverage/lcov-report/
            
variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    - merge_requests
    - master
    - develop
